# Cinder

# cinder::ColorAT< T > Class Template Reference

`#include <Color.h>`

List of all members.

## Public Member Functions
| ColorAT ()
| ColorAT (T aR, T aG, T aB, T aA=CHANTRAIT< T >::convert(1.0f))
| ColorAT (const ColorAT< T > &src)
| ColorAT (const ColorT< T > &col, T aA=CHANTRAIT< T >::convert(1.0f))
| ColorAT (ColorModel cm, float c1, float c2, float c3, float aA=CHANTRAIT< T >::convert(1.0f))
template<typename FromT >
| ColorAT (const ColorAT< FromT > &src)
ColorAT< T > | operator= (const ColorAT< T > &rhs)
template<class FromT >
ColorAT< T > | operator= (const ColorAT< FromT > &rhs)
T & | operator[] (int n)
ColorAT< T > | operator+ (const ColorAT< T > &rhs) const
ColorAT< T > | operator- (const ColorAT< T > &rhs) const
ColorAT< T > | operator* (const ColorAT< T > &rhs) const
ColorAT< T > | operator/ (const ColorAT< T > &rhs) const
const ColorAT< T > & | operator+= (const ColorAT< T > &rhs)
const ColorAT< T > & | operator-= (const ColorAT< T > &rhs)
const ColorAT< T > & | operator*= (const ColorAT< T > &rhs)
const ColorAT< T > & | operator/= (const ColorAT< T > &rhs)
ColorAT< T > | operator+ (T rhs) const
ColorAT< T > | operator- (T rhs) const
ColorAT< T > | operator* (T rhs) const
ColorAT< T > | operator/ (T rhs) const
const ColorAT< T > & | operator+= (T rhs)
const ColorAT< T > & | operator-= (T rhs)
const ColorAT< T > & | operator*= (T rhs)
const ColorAT< T > & | operator/= (T rhs)
float | length () const
void | normalize ()
ColorAT< T > | premultiplied () const
CHANTRAIT< T >::Accum | lengthSquared () const
ColorAT< T > | lerp (T fact, const ColorAT< T > &d) const
| operator T * ()
| operator const T * () const
| operator ColorT< T > ()
template<>
const ColorAT< uint8_t > & | operator*= (const ColorAT< uint8_t > &rhs)
template<>
const ColorAT< uint8_t > & | operator*= (uint8_t rhs)
template<>
ColorAT< uint8_t > | operator* (const ColorAT< uint8_t > &rhs) const
template<>
ColorAT< uint8_t > | operator* (uint8_t rhs) const
template<>
const ColorAT< uint8_t > & | operator/= (const ColorAT< uint8_t > &rhs)
template<>
const ColorAT< uint8_t > & | operator/= (uint8_t rhs)
template<>
ColorAT< uint8_t > | operator/ (const ColorAT< uint8_t > &rhs) const
template<>
ColorAT< uint8_t > | operator/ (uint8_t rhs) const
template<>
ColorAT< uint8_t > | lerp (uint8_t fact, const ColorAT< uint8_t > &d) const
## Static Public Member Functions
static ColorAT< T > | zero ()
static ColorAT< T > | black ()
## Public Attributes
T | r
T | g
T | b
T | a

### template<typename T>
class cinder::ColorAT< T >

## Constructor & Destructor Documentation

template<typename T>

cinder::ColorAT< T >::ColorAT | ( |  | ) |

template<typename T>

cinder::ColorAT< T >::ColorAT | ( | T | aR,
|  | T | aG,
|  | T | aB,
|  | T | aA = `CHANTRAIT<T>::convert( 1.0f )` |
| ) |  |  |

template<typename T>

cinder::ColorAT< T >::ColorAT | ( | const ColorAT< T > & | src | ) |

template<typename T>

cinder::ColorAT< T >::ColorAT | ( | const ColorT< T > & | col,
|  | T | aA = `CHANTRAIT<T>::convert( 1.0f )` |
| ) |  |  |

template<typename T>

cinder::ColorAT< T >::ColorAT | ( | ColorModel | cm,
|  | float | c1,
|  | float | c2,
|  | float | c3,
|  | float | aA = `CHANTRAIT<T>::convert( 1.0f )` |
| ) |  |  |

template<typename T>
template<typename FromT >

cinder::ColorAT< T >::ColorAT | ( | const ColorAT< FromT > & | src | ) |

## Member Function Documentation

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator= | ( | const ColorAT< T > & | rhs | ) |

template<typename T>
template<class FromT >

ColorAT<T> cinder::ColorAT< T >::operator= | ( | const ColorAT< FromT > & | rhs | ) |

template<typename T>

T& cinder::ColorAT< T >::operator[] | ( | int | n | ) |

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator+ | ( | const ColorAT< T > & | rhs | ) | const

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator- | ( | const ColorAT< T > & | rhs | ) | const

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator* | ( | const ColorAT< T > & | rhs | ) | const

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator/ | ( | const ColorAT< T > & | rhs | ) | const

template<typename T>

const ColorAT<T>& cinder::ColorAT< T >::operator+= | ( | const ColorAT< T > & | rhs | ) |

template<typename T>

const ColorAT<T>& cinder::ColorAT< T >::operator-= | ( | const ColorAT< T > & | rhs | ) |

template<typename T>

const ColorAT<T>& cinder::ColorAT< T >::operator*= | ( | const ColorAT< T > & | rhs | ) |

template<typename T>

const ColorAT<T>& cinder::ColorAT< T >::operator/= | ( | const ColorAT< T > & | rhs | ) |

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator+ | ( | T | rhs | ) | const

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator- | ( | T | rhs | ) | const

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator* | ( | T | rhs | ) | const

template<typename T>

ColorAT<T> cinder::ColorAT< T >::operator/ | ( | T | rhs | ) | const

template<typename T>

const ColorAT<T>& cinder::ColorAT< T >::operator+= | ( | T | rhs | ) |

template<typename T>

const ColorAT<T>& cinder::ColorAT< T >::operator-= | ( | T | rhs | ) |

template<typename T>

const ColorAT<T>& cinder::ColorAT< T >::operator*= | ( | T | rhs | ) |

template<typename T>

const ColorAT<T>& cinder::ColorAT< T >::operator/= | ( | T | rhs | ) |

template<typename T>

float cinder::ColorAT< T >::length | ( |  | ) | const

template<typename T>

void cinder::ColorAT< T >::normalize | ( |  | ) |

template<typename T>

ColorAT<T> cinder::ColorAT< T >::premultiplied | ( |  | ) | const

template<typename T>

CHANTRAIT<T>::Accum cinder::ColorAT< T >::lengthSquared | ( |  | ) | const

template<typename T>

ColorAT<T> cinder::ColorAT< T >::lerp | ( | T | fact,
|  | const ColorAT< T > & | d |
| ) |  |  | const

template<typename T>

static ColorAT<T> cinder::ColorAT< T >::zero | ( |  | ) | `[static]`

template<typename T>

static ColorAT<T> cinder::ColorAT< T >::black | ( |  | ) | `[static]`

template<typename T>

cinder::ColorAT< T >::operator T * | ( |  | ) |

template<typename T>

cinder::ColorAT< T >::operator const T * | ( |  | ) | const

template<typename T>

cinder::ColorAT< T >::operator ColorT< T > | ( |  | ) |

template<>

const ColorAT< uint8_t > & cinder::ColorAT< uint8_t >::operator*= | ( | const ColorAT< uint8_t > & | rhs | ) |

template<>

const ColorAT< uint8_t > & cinder::ColorAT< uint8_t >::operator*= | ( | uint8_t | rhs | ) |

template<>

ColorAT< uint8_t > cinder::ColorAT< uint8_t >::operator* | ( | const ColorAT< uint8_t > & | rhs | ) | const

template<>

ColorAT< uint8_t > cinder::ColorAT< uint8_t >::operator* | ( | uint8_t | rhs | ) | const

template<>

const ColorAT< uint8_t > & cinder::ColorAT< uint8_t >::operator/= | ( | const ColorAT< uint8_t > & | rhs | ) |

template<>

const ColorAT< uint8_t > & cinder::ColorAT< uint8_t >::operator/= | ( | uint8_t | rhs | ) |

template<>

ColorAT< uint8_t > cinder::ColorAT< uint8_t >::operator/ | ( | const ColorAT< uint8_t > & | rhs | ) | const

template<>

ColorAT< uint8_t > cinder::ColorAT< uint8_t >::operator/ | ( | uint8_t | rhs | ) | const

template<>

ColorAT< uint8_t > cinder::ColorAT< uint8_t >::lerp | ( | uint8_t | fact,
|  | const ColorAT< uint8_t > & | d |
| ) |  |  | const

## Member Data Documentation

template<typename T>

T cinder::ColorAT< T >::r

template<typename T>

T cinder::ColorAT< T >::g

template<typename T>

T cinder::ColorAT< T >::b

template<typename T>

T cinder::ColorAT< T >::a

The documentation for this class was generated from the following files:

- include/cinder/Color.h
- src/cinder/Color.cpp